<?php
namespace EMS\PortalFuncionario\Geral\Services;

use Zeedhi\Framework\Controller\Crud;
use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Geral\Repository\GeralRepository;
use EMS\PortalFuncionario\Util\DateUtil;

class GeralService {
    /** @var GeralRepository */
    protected $geralRepository;

    public function __construct(EntityManager $entityManager, GeralRepository $geralRepository) {
		$this->entityManager     = $entityManager;
		$this->geralRepository   = $geralRepository;
    }

    public function getAniversariantes(
        int $nrOrg,
            $dtmescompetenc = null
    ): array {
        $aniversariantes = $this->geralRepository->getAniversariantes(
            $nrOrg,
            $dtmescompetenc
        );

        usort($aniversariantes, function($a, $b) {
            return self::sortAniver($a, $b);
        });

        return $aniversariantes;
    }

    public static function sortAniver(
        array $a,
        array $b
    ): int {
        $currentDate = DateUtil::getDataAtual()->format(DateUtil::FORMATO_BRASILEIRO);
        $currentDay = intval(substr($currentDate, 0, 2));

        $dayA = intval(substr($a['DTANIVERSARIO'], 0, 2));
        $dayB = intval(substr($b['DTANIVERSARIO'], 0, 2));

        if ($currentDay === $dayA) {
            return -1;
        }

        if ($currentDay === $dayB) {
            return 1;
        }

        return $dayA - $dayB;
    }

}